RCDoubleMatrix2D (Colt 1.2.0 - API Specification)
Keywords: cern.colt.matrix.impl.RCDoubleMatrix2D class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Colt 1.2.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## cern.colt.matrix.impl
Class RCDoubleMatrix2D

    java.lang.Object
      cern.colt.PersistentObject
          cern.colt.matrix.impl.AbstractMatrix
              cern.colt.matrix.impl.AbstractMatrix2D
                  cern.colt.matrix.DoubleMatrix2D
                      cern.colt.matrix.impl.WrapperDoubleMatrix2D
                          cern.colt.matrix.impl.RCDoubleMatrix2D

All Implemented Interfaces:
  Cloneable, Serializable

public class RCDoubleMatrix2D
extends cern.colt.matrix.impl.WrapperDoubleMatrix2D

Sparse row-compressed 2-d matrix holding `double` elements. First see the package summary and javadoc tree view to get the broad picture.

Implementation:

Internally uses the standard sparse row-compressed format, with two important differences that broaden the applicability of this storage format:

- We use a `IntArrayList` and `DoubleArrayList` to hold the column indexes and nonzero values, respectively. This improves set(...) performance, because the standard way of using non-resizable primitive arrays causes excessive memory allocation, garbage collection and array copying. The small downside of this is that set(...,0) does not free memory (The capacity of an arraylist does not shrink upon element removal).
- Column indexes are kept sorted within a row. This both improves get and set performance on rows with many non-zeros, because we can use a binary search. (Experiments show that this hurts < 10% on rows with < 4 nonZeros.)

Note that this implementation is not synchronized.

Memory requirements:

Cells that

- are never set to non-zero values do not use any memory.
- switch from zero to non-zero state do use memory.
- switch back from non-zero to zero state also do use memory. Their memory is not automatically reclaimed (because of the lists vs. arrays). Reclamation can be triggered via `trimToSize()`.

`memory [bytes] = 4*rows + 12 * nonZeros`.
Where `nonZeros = cardinality()` is the number of non-zero cells. Thus, a 1000 x 1000 matrix with 1000000 non-zero cells consumes 11.5 MB. The same 1000 x 1000 matrix with 1000 non-zero cells consumes 15 KB.

Time complexity:

Getting a cell value takes time`O(log nzr)` where `nzr` is the number of non-zeros of the touched row. This is usually quick, because typically there are only few nonzeros per row. So, in practice, get has expected constant time. Setting a cell value takes worst-case time `O(nz)` where `nzr` is the total number of non-zeros in the matrix. This can be extremely slow, but if you traverse coordinates properly (i.e. upwards), each write is done much quicker:

    // rather quick
    matrix.assign(0);
    for (int row=0; row < rows; row++) {
       for (int column=0; column < columns; column++) {
          if (someCondition) matrix.setQuick(row,column,someValue);
       }
    }

    // poor
    matrix.assign(0);
    for (int row=rows; --row >= 0; ) {
       for (int column=columns; --column >= 0; ) {
          if (someCondition) matrix.setQuick(row,column,someValue);
       }
    }

If for whatever reasons you can't iterate properly, consider to create an empty dense matrix, store your non-zeros in it, then call `sparse.assign(dense)`. Under the circumstances, this is still rather quick.

Fast iteration over non-zeros can be done via `forEachNonZero(cern.colt.function.IntIntDoubleFunction)`, which supplies your function with row, column and value of each nonzero. Although the internally implemented version is a bit more sophisticated, here is how a quite efficient user-level matrix-vector multiplication could look like:

    // Linear algebraic y = A * x
    A.forEachNonZero(
       new cern.colt.function.IntIntDoubleFunction() {
          public double apply(int row, int column, double value) {
             y.setQuick(row,y.getQuick(row) + value * x.getQuick(column));
             return value;
          }
       }
    );

Here is how a a quite efficient user-level combined scaling operation could look like:

    // Elementwise A = A + alpha*B
    B.forEachNonZero(
       new cern.colt.function.IntIntDoubleFunction() {
          public double apply(int row, int column, double value) {
             A.setQuick(row,column,A.getQuick(row,column) + alpha*value);
             return value;
          }
       }
    );

Method `assign(DoubleMatrix2D,cern.colt.function.DoubleDoubleFunction)` does just that if you supply `Functions.plusMult(double)` as argument.

Version:
  0.9, 04/14/2000
See Also:
  Serialized Form

Field Summary

Fields inherited from class cern.colt.PersistentObject
`serialVersionUID`

Constructor Summary
`RCDoubleMatrix2D(double[][] values)` Constructs a matrix with a copy of the given values.
`RCDoubleMatrix2D(int rows, int columns)` Constructs a matrix with a given number of rows and columns.

Method Summary
`DoubleMatrix2D` | `assign(double value)` Sets all cells to the state specified by `value`.
`DoubleMatrix2D` | `assign(DoubleFunction function)` Assigns the result of a function to each cell; `x[row,col] = function(x[row,col])`.
`DoubleMatrix2D` | `assign(DoubleMatrix2D source)` Replaces all cell values of the receiver with the values of another matrix.
`DoubleMatrix2D` | `assign(DoubleMatrix2D y, DoubleDoubleFunction function)` Assigns the result of a function to each cell; `x[row,col] = function(x[row,col],y[row,col])`.
`DoubleMatrix2D` | `forEachNonZero(IntIntDoubleFunction function)` Assigns the result of a function to each non-zero cell; `x[row,col] = function(x[row,col])`.
`double` | `getQuick(int row, int column)` Returns the matrix cell value at coordinate `[row,column]`.
`DoubleMatrix2D` | `like(int rows, int columns)` Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of rows and columns.
`DoubleMatrix1D` | `like1D(int size)` Construct and returns a new 1-d matrix of the corresponding dynamic type, entirelly independent of the receiver.
`void` | `setQuick(int row, int column, double value)` Sets the matrix cell at coordinate `[row,column]` to the specified value.
`void` | `trimToSize()` Releases any superfluous internal memory.
`DoubleMatrix1D` | `viewColumn(int column)` Constructs and returns a new slice view representing the rows of the given column.
`DoubleMatrix2D` | `viewColumnFlip()` Constructs and returns a new flip view along the column axis.
`DoubleMatrix2D` | `viewDice()` Constructs and returns a new dice (transposition) view; Swaps axes; example: 3 x 4 matrix --> 4 x 3 matrix.
`DoubleMatrix2D` | `viewPart(int row, int column, int height, int width)` Constructs and returns a new sub-range view that is a `height x width` sub matrix starting at `[row,column]`.
`DoubleMatrix1D` | `viewRow(int row)` Constructs and returns a new slice view representing the columns of the given row.
`DoubleMatrix2D` | `viewRowFlip()` Constructs and returns a new flip view along the row axis.
`DoubleMatrix2D` | `viewSelection(int[] rowIndexes, int[] columnIndexes)` Constructs and returns a new selection view that is a matrix holding the indicated cells.
`DoubleMatrix2D` | `viewStrides(int _rowStride, int _columnStride)` Constructs and returns a new stride view which is a sub matrix consisting of every i-th cell.
`DoubleMatrix1D` | `zMult(DoubleMatrix1D y, DoubleMatrix1D z, double alpha, double beta, boolean transposeA)` Linear algebraic matrix-vector multiplication; `z = alpha * A * y + beta*z`.
`DoubleMatrix2D` | `zMult(DoubleMatrix2D B, DoubleMatrix2D C, double alpha, double beta, boolean transposeA, boolean transposeB)` Linear algebraic matrix-matrix multiplication; `C = alpha * A x B + beta*C`.

Methods inherited from class cern.colt.matrix.DoubleMatrix2D
`aggregate, aggregate, assign, cardinality, copy, equals, equals, get, getNonZeros, like, set, toArray, toString, viewSelection, viewSorted, zAssign8Neighbors, zMult, zMult, zSum`

Methods inherited from class cern.colt.matrix.impl.AbstractMatrix2D
`checkShape, checkShape, columns, rows, size, toStringShort`

Methods inherited from class cern.colt.matrix.impl.AbstractMatrix
`ensureCapacity`

Methods inherited from class cern.colt.PersistentObject
`clone`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### RCDoubleMatrix2D

    public RCDoubleMatrix2D(double[][] values)

  Constructs a matrix with a copy of the given values. `values` is required to have the form `values[row][column]` and have exactly the same number of columns in every row.

  The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

Parameters:
  `values` - The values to be filled into the new matrix.
Throws:
  `IllegalArgumentException` - if `for any 1 <= row < values.length: values[row].length != values[row-1].length`.

### RCDoubleMatrix2D

    public RCDoubleMatrix2D(int rows,
                            int columns)

  Constructs a matrix with a given number of rows and columns. All entries are initially `0`.

Parameters:
  `rows` - the number of rows the matrix shall have.
  `columns` - the number of columns the matrix shall have.
Throws:
  `IllegalArgumentException` - if `rows<0 || columns<0 || (double)columns*rows > Integer.MAX_VALUE`.

Method Detail

### assign

    public DoubleMatrix2D assign(double value)

  Sets all cells to the state specified by `value`.

  Overrides:
    `assign` in class `DoubleMatrix2D`
  Parameters:
    `value` - the value to be filled into the cells.
  Returns:
    `this` (for convenience only).

### assign

    public DoubleMatrix2D assign(DoubleFunction function)

  Description copied from class: `DoubleMatrix2D`
  Assigns the result of a function to each cell; `x[row,col] = function(x[row,col])`.

  Example:

      matrix = 2 x 2 matrix
      0.5 1.5
      2.5 3.5

      // change each cell to its sine
      matrix.assign(cern.jet.math.Functions.sin);
      -->
      2 x 2 matrix
      0.479426  0.997495
      0.598472 -0.350783

  For further examples, see the package doc.

  Overrides:
    `assign` in class `DoubleMatrix2D`
  Parameters:
    `function` - a function object taking as argument the current cell's value.
  Returns:
    `this` (for convenience only).
  See Also:
    `Functions`

### assign

    public DoubleMatrix2D assign(DoubleMatrix2D source)

  Replaces all cell values of the receiver with the values of another matrix. Both matrices must have the same number of rows and columns. If both matrices share the same cells (as is the case if they are views derived from the same matrix) and intersect in an ambiguous way, then replaces as if using an intermediate auxiliary deep copy of `other`.

  Overrides:
    `assign` in class `DoubleMatrix2D`
  Parameters:
    `source` - the source matrix to copy from (may be identical to the receiver).
  Returns:
    `this` (for convenience only).
  Throws:
    `IllegalArgumentException` - if `columns() != source.columns() || rows() != source.rows()`

### assign

    public DoubleMatrix2D assign(DoubleMatrix2D y,
                                 DoubleDoubleFunction function)

  Description copied from class: `DoubleMatrix2D`
  Assigns the result of a function to each cell; `x[row,col] = function(x[row,col],y[row,col])`.

  Example:

      // assign x[row,col] = x[row,col]y[row,col]
      m1 = 2 x 2 matrix
      0 1
      2 3

      m2 = 2 x 2 matrix
      0 2
      4 6

      m1.assign(m2, cern.jet.math.Functions.pow);
      -->
      m1 == 2 x 2 matrix
       1   1
      16 729

  For further examples, see the package doc.

  Overrides:
    `assign` in class `DoubleMatrix2D`
  Parameters:
    `y` - the secondary matrix to operate on.
    `function` - a function object taking as first argument the current cell's value of `this`, and as second argument the current cell's value of `y`,
  Returns:
    `this` (for convenience only).
  See Also:
    `Functions`

### forEachNonZero

    public DoubleMatrix2D forEachNonZero(IntIntDoubleFunction function)

  Description copied from class: `DoubleMatrix2D`
  Assigns the result of a function to each non-zero cell; `x[row,col] = function(x[row,col])`. Use this method for fast special-purpose iteration. If you want to modify another matrix instead of `this` (i.e. work in read-only mode), simply return the input value unchanged. Parameters to function are as follows: `first==row`, `second==column`, `third==nonZeroValue`.

  Overrides:
    `forEachNonZero` in class `DoubleMatrix2D`
  Parameters:
    `function` - a function object taking as argument the current non-zero cell's row, column and value.
  Returns:
    `this` (for convenience only).

### getQuick

    public double getQuick(int row,
                           int column)

  Returns the matrix cell value at coordinate `[row,column]`.

  Provided with invalid parameters this method may return invalid objects without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `0 <= column < columns() && 0 <= row < rows()`.

  Parameters:
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
  Returns:
    the value at the specified coordinate.

### like

    public DoubleMatrix2D like(int rows,
                               int columns)

  Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of rows and columns. For example, if the receiver is an instance of type `DenseDoubleMatrix2D` the new matrix must also be of type `DenseDoubleMatrix2D`, if the receiver is an instance of type `SparseDoubleMatrix2D` the new matrix must also be of type `SparseDoubleMatrix2D`, etc. In general, the new matrix should have internal parametrization as similar as possible.

  Parameters:
    `rows` - the number of rows the matrix shall have.
    `columns` - the number of columns the matrix shall have.
  Returns:
    a new empty matrix of the same dynamic type.

### like1D

    public DoubleMatrix1D like1D(int size)

  Construct and returns a new 1-d matrix of the corresponding dynamic type, entirelly independent of the receiver. For example, if the receiver is an instance of type `DenseDoubleMatrix2D` the new matrix must be of type `DenseDoubleMatrix1D`, if the receiver is an instance of type `SparseDoubleMatrix2D` the new matrix must be of type `SparseDoubleMatrix1D`, etc.

  Parameters:
    `size` - the number of cells the matrix shall have.
  Returns:
    a new matrix of the corresponding dynamic type.

### setQuick

    public void setQuick(int row,
                         int column,
                         double value)

  Sets the matrix cell at coordinate `[row,column]` to the specified value.

  Provided with invalid parameters this method may access illegal indexes without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `0 <= column < columns() && 0 <= row < rows()`.

  Parameters:
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
    `value` - the value to be filled into the specified cell.

### trimToSize

    public void trimToSize()

  Description copied from class: `AbstractMatrix`
  Releases any superfluous internal memory. An application can use this operation to minimize the storage of the receiver.

  This default implementation does nothing. Override this method if necessary.

  Overrides:
    `trimToSize` in class `AbstractMatrix`

### zMult

    public DoubleMatrix1D zMult(DoubleMatrix1D y,
                                DoubleMatrix1D z,
                                double alpha,
                                double beta,
                                boolean transposeA)

  Description copied from class: `DoubleMatrix2D`
  Linear algebraic matrix-vector multiplication; `z = alpha * A * y + beta*z`. `z[i] = alpha*Sum(A[i,j] * y[j]) + beta*z[i], i=0..A.rows()-1, j=0..y.size()-1`. Where `A == this`.
  Note: Matrix shape conformance is checked after potential transpositions.

  Overrides:
    `zMult` in class `DoubleMatrix2D`
  Parameters:
    `y` - the source vector.
    `z` - the vector where results are to be stored. Set this parameter to `null` to indicate that a new result vector shall be constructed.
  Returns:
    z (for convenience only).

### zMult

    public DoubleMatrix2D zMult(DoubleMatrix2D B,
                                DoubleMatrix2D C,
                                double alpha,
                                double beta,
                                boolean transposeA,
                                boolean transposeB)

  Description copied from class: `DoubleMatrix2D`
  Linear algebraic matrix-matrix multiplication; `C = alpha * A x B + beta*C`. `C[i,j] = alpha*Sum(A[i,k] * B[k,j]) + beta*C[i,j], k=0..n-1`.
  Matrix shapes: `A(m x n), B(n x p), C(m x p)`.
  Note: Matrix shape conformance is checked after potential transpositions.

  Overrides:
    `zMult` in class `DoubleMatrix2D`
  Parameters:
    `B` - the second source matrix.
    `C` - the matrix where results are to be stored. Set this parameter to `null` to indicate that a new result matrix shall be constructed.
  Returns:
    C (for convenience only).

### viewColumn

    public DoubleMatrix1D viewColumn(int column)

  Constructs and returns a new slice view representing the rows of the given column. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa. To obtain a slice view on subranges, construct a sub-ranging view (`viewPart(...)`), then apply this method to the sub-range view.

  Example:

  2 x 3 matrix: 1, 2, 3 4, 5, 6 | viewColumn(0) ==> | Matrix1D of size 2: 1, 4

  Overrides:
    `viewColumn` in class `DoubleMatrix2D`
  Parameters:
    `column` - the column to fix.
  Returns:
    a new slice view.
  Throws:
    `IndexOutOfBoundsException` - if `column < 0 || column >= columns()`.
  See Also:
    `WrapperDoubleMatrix2D.viewRow(int)`

### viewColumnFlip

    public DoubleMatrix2D viewColumnFlip()

  Constructs and returns a new flip view along the column axis. What used to be column `0` is now column `columns()-1`, ..., what used to be column `columns()-1` is now column `0`. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Example:

  2 x 3 matrix: 1, 2, 3 4, 5, 6 | columnFlip ==> | 2 x 3 matrix: 3, 2, 1 6, 5, 4 | columnFlip ==> | 2 x 3 matrix: 1, 2, 3 4, 5, 6

  Overrides:
    `viewColumnFlip` in class `DoubleMatrix2D`
  Returns:
    a new flip view.
  See Also:
    `WrapperDoubleMatrix2D.viewRowFlip()`

### viewDice

    public DoubleMatrix2D viewDice()

  Constructs and returns a new dice (transposition) view; Swaps axes; example: 3 x 4 matrix --> 4 x 3 matrix. The view has both dimensions exchanged; what used to be columns become rows, what used to be rows become columns. In other words: `view.get(row,column)==this.get(column,row)`. This is a zero-copy transposition, taking O(1), i.e. constant time. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa. Use idioms like `result = viewDice(A).copy()` to generate an independent transposed matrix.

  Example:

  2 x 3 matrix: 1, 2, 3 4, 5, 6 | transpose ==> | 3 x 2 matrix: 1, 4 2, 5 3, 6 | transpose ==> | 2 x 3 matrix: 1, 2, 3 4, 5, 6

  Overrides:
    `viewDice` in class `DoubleMatrix2D`
  Returns:
    a new dice view.

### viewPart

    public DoubleMatrix2D viewPart(int row,
                                   int column,
                                   int height,
                                   int width)

  Constructs and returns a new sub-range view that is a `height x width` sub matrix starting at `[row,column]`. Operations on the returned view can only be applied to the restricted range. Any attempt to access coordinates not contained in the view will throw an `IndexOutOfBoundsException`.

  Note that the view is really just a range restriction: The returned matrix is backed by this matrix, so changes in the returned matrix are reflected in this matrix, and vice-versa.

  The view contains the cells from `[row,column]` to `[row+height-1,column+width-1]`, all inclusive. and has `view.rows() == height; view.columns() == width;`. A view's legal coordinates are again zero based, as usual. In other words, legal coordinates of the view range from `[0,0]` to `[view.rows()-1==height-1,view.columns()-1==width-1]`. As usual, any attempt to access a cell at a coordinate `column<0 || column>=view.columns() || row<0 || row>=view.rows()` will throw an `IndexOutOfBoundsException`.

  Overrides:
    `viewPart` in class `DoubleMatrix2D`
  Parameters:
    `row` - The index of the row-coordinate.
    `column` - The index of the column-coordinate.
    `height` - The height of the box.
    `width` - The width of the box.
  Returns:
    the new view.
  Throws:
    `IndexOutOfBoundsException` - if `column<0 || width<0 || column+width>columns() || row<0 || height<0 || row+height>rows()`

### viewRow

    public DoubleMatrix1D viewRow(int row)

  Constructs and returns a new slice view representing the columns of the given row. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa. To obtain a slice view on subranges, construct a sub-ranging view (`viewPart(...)`), then apply this method to the sub-range view.

  Example:

  2 x 3 matrix: 1, 2, 3 4, 5, 6 | viewRow(0) ==> | Matrix1D of size 3: 1, 2, 3

  Overrides:
    `viewRow` in class `DoubleMatrix2D`
  Parameters:
    `row` - the row to fix.
  Returns:
    a new slice view.
  Throws:
    `IndexOutOfBoundsException` - if `row < 0 || row >= rows()`.
  See Also:
    `WrapperDoubleMatrix2D.viewColumn(int)`

### viewRowFlip

    public DoubleMatrix2D viewRowFlip()

  Constructs and returns a new flip view along the row axis. What used to be row `0` is now row `rows()-1`, ..., what used to be row `rows()-1` is now row `0`. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Example:

  2 x 3 matrix: 1, 2, 3 4, 5, 6 | rowFlip ==> | 2 x 3 matrix: 4, 5, 6 1, 2, 3 | rowFlip ==> | 2 x 3 matrix: 1, 2, 3 4, 5, 6

  Overrides:
    `viewRowFlip` in class `DoubleMatrix2D`
  Returns:
    a new flip view.
  See Also:
    `WrapperDoubleMatrix2D.viewColumnFlip()`

### viewSelection

    public DoubleMatrix2D viewSelection(int[] rowIndexes,
                                        int[] columnIndexes)

  Constructs and returns a new selection view that is a matrix holding the indicated cells. There holds `view.rows() == rowIndexes.length, view.columns() == columnIndexes.length` and `view.get(i,j) == this.get(rowIndexes[i],columnIndexes[j])`. Indexes can occur multiple times and can be in arbitrary order.

  Example:

      this = 2 x 3 matrix:
      1, 2, 3
      4, 5, 6
      rowIndexes     = (0,1)
      columnIndexes  = (1,0,1,0)
      -->
      view = 2 x 4 matrix:
      2, 1, 2, 1
      5, 4, 5, 4

  Note that modifying the index arguments after this call has returned has no effect on the view. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  To indicate "all" rows or "all columns", simply set the respective parameter

  Overrides:
    `viewSelection` in class `DoubleMatrix2D`
  Parameters:
    `rowIndexes` - The rows of the cells that shall be visible in the new view. To indicate that all rows shall be visible, simply set this parameter to `null`.
    `columnIndexes` - The columns of the cells that shall be visible in the new view. To indicate that all columns shall be visible, simply set this parameter to `null`.
  Returns:
    the new view.
  Throws:
    `IndexOutOfBoundsException` - if `!(0 <= rowIndexes[i] < rows())` for any `i=0..rowIndexes.length()-1`.
    `IndexOutOfBoundsException` - if `!(0 <= columnIndexes[i] < columns())` for any `i=0..columnIndexes.length()-1`.

### viewStrides

    public DoubleMatrix2D viewStrides(int _rowStride,
                                      int _columnStride)

  Constructs and returns a new stride view which is a sub matrix consisting of every i-th cell. More specifically, the view has `this.rows()/rowStride` rows and `this.columns()/columnStride` columns holding cells `this.get(i*rowStride,j*columnStride)` for all `i = 0..rows()/rowStride - 1, j = 0..columns()/columnStride - 1`. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Overrides:
    `viewStrides` in class `DoubleMatrix2D`
  Parameters:
    `_rowStride` - the row step factor.
    `_columnStride` - the column step factor.
  Returns:
    a new view.
  Throws:
    `IndexOutOfBoundsException` - if `rowStride<=0 || columnStride<=0`.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Colt 1.2.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Jump to the Colt Homepage